<%@CODEPAGE=65001%>
<%
  rem *********************************************************************
  rem ** DISCLAIMER AND LICENSE                                          **
  rem ** The author of this code makes no guarantees and is not          **
  rem ** responsible for any damage resulting from its use.              **
  rem ** You may modify the code for your own use in any way you like,   **
  rem ** but it may only be distributed in its original form.            **
  rem ** The VBScript punycode conversion functions in this code is      **
  rem ** derived from the sample C code in RFC 3492.                     **
  rem ** Author: Jesper G. Hy - JH Software ApS - www.jhsoft.com        **
  rem *********************************************************************

  Response.Charset="UTF-8"

   If Request.ServerVariables("HTTP_METHOD")="POST" Then 
     fNative=Trim(Request.Form("native"))
     fPunyCode=Trim(Request.Form("punycode"))
     ErrMsg=""
     If Request.Form("btnCN")>"" Then
       On Error Resume Next
       fPunyCode=DomainPunyEncode(fNative)
       If Err.Number<>0 Then ErrMsg=Err.Description
       On Error Goto 0
     ElseIf Request.Form("btnCP")>"" Then
       On Error Resume Next
       fNative=DomainPunyDecode(fPunyCode)
       If Err.Number<>0 Then ErrMsg=Err.Description
       On Error Goto 0
     End If
   End If
%>
<html>
<head>
<title>IDN Conversion Tool</title>
</head>
<body>
      <h1 align="center">IDN Conversion Tool</h1>

      <p align=center>When working with a domain name containing international (non-english) characters,<br>
      you need to convert the domain name into &quot;punycode&quot; before entering it into the<br>
      DNS server (such as <a href="http://www.simpledns.com/?source=idnscript" target=_blank>Simple DNS Plus</a>)
      and other server programs (such as IIS/Apache).<br>
      <br>
      You can use this function to convert your domain names forth and back<br>
      between native character format and punycode:</p>

<% If ErrMsg>"" Then %>          
<p align=center><font color=red><b>ERROR: <%=ErrMsg%></b></font></p>
<% End If %>   

      <div align="center">      
<form method=post>      
<table bgcolor="#DAE2E9" cellpadding=5 style="border: solid 1px navy">
<tr><td align=right>Native characters:</td>
  <td><input type=text style="width:300" name=native value="<%=Server.HTMLEncode(fNative)%>">
  <input type=submit name=btnCN value="Convert"></td></tr>
<tr><td align=right>Punycode:</td>
  <td><input type=text style="width:300" name=punycode value="<%=Server.HTMLEncode(fPunyCode)%>">
  <input type=submit name=btnCP value="Convert"></td></tr>
</table>
</form>
    
</div>

<br>
<p align=center>This IDN Conversion Tool is powered by script code from JH Software,<br>
the author of the Windows DNS server software
<a href="http://www.simpledns.com/?source=idnscript" target=_blank>Simple DNS Plus</a></p>

</body>
</html>


<%
  rem -------------------------------- punycode functions ----------------------------
    
Function IIf(a,b,c)
  If a Then IIf=b Else IIf=c
End Function

Function DomainPunyEncode(ByVal domStr)
  Dim i, segStr, segPuny, x, outStr
  domStr = LCase(Trim(domStr))
  outStr = ""
  While Len(domStr) > 0
    i = Instr(domStr,".")-1
    If i < 0 Then i = len(domStr)
    If i = 0 Then Err.Raise vbObjectError + 513, , "Invalid placement of dot in domain name"
    If i > 63 Then Err.Raise vbObjectError + 513, , "Invalid domain name - segment between dots longer than 63 characters"
    segStr = left(domStr,i)
    domStr = Mid(domStr, i + 2)
    segPuny = False
    REM check valid chars
    For i = 1 To len(segStr) 
      If AscW(mid(segStr,i,1)) > 127 Then
        segPuny = True
      Else
        If Instr("abcdefghijklmnopqrstuvwxyz0123456789-",mid(segStr,i,1)) = 0 Then Err.Raise vbObjectError + 513, , "Invalid character in domain name"
      End If
    Next
    If segPuny Then x = "xn--" & PunyEncode(segStr) Else x = segStr
    If len(x) > 63 Then Err.Raise vbObjectError + 513, , "Invalid domain name - encoded segment longer than 63 characters"
    outStr = outStr & IIf(len(outStr) > 0, ".", "") & x
  Wend
  DomainPunyEncode=outStr
End Function

Function DomainPunyDecode(ByVal domStr)
  Dim i, segStr, outStr
  domStr = LCase(Trim(domStr))
  outStr = ""
  While len(domStr) > 0
    i = instr(domStr,".")-1
    If i < 0 Then i = len(domStr)
    If i = 0 Then Err.Raise vbObjectError + 513, , "Invalid placement of dot in domain name"
    If i > 63 Then Err.Raise vbObjectError + 513, , "Invalid domain name - segment between dots longer than 63 characters"
    segStr =left(domStr,i)
    domStr = Mid(domStr, i + 2)
    REM check valid chars
    For i = 1 To len(segStr)
      If instr("abcdefghijklmnopqrstuvwxyz0123456789-",mid(segstr,i,1))=0 Then Err.Raise vbObjectError + 513, , "Invalid character in domain name"
    Next
    If Left(segStr, 4) = "xn--" Then
      outStr=outStr & IIf(len(outStr) > 0, ".", "") & PunyDecode(mid(segStr,5))
    Else
      outStr=outStr & IIf(len(outStr) > 0, ".", "") & segStr
    End If
  Wend
  DomainPunyDecode=outStr
End Function

Function PunyDecode(ByVal pc)
Dim outBufPos, i, digit, outStr, bias, n, t, pcPos, oldi, w, k
  outBufPos = 0
  outStr = ""

  REM handle basic code points (clear text)
  i = InStrRev(pc, "-") - 1
  If i >= 0 Then
    outBufPos = i
    outStr =Left(pc,i)
    pc =mid(pc,i+2)
  End If

  REM main decoding loop
  i = 0
  bias = 72
  n = 128
  pcPos = 0

  Do While pcPos < len(pc)
    oldi = i
    w = 1
    k = 36
    Do
      If pcPos >= len(pc) Then Err.Raise vbObjectError + 513, , "Not a valid punycode domain. Bad input."
      digit = PunyDecodeDigit(AscW(Mid(pc,pcPos+1,1)))
      pcPos=pcPos + 1
      i=i + digit * w
      t = IIf(k <= bias, 1, IIf(k >= bias + 26, 26, k - bias))
      If digit < t Then Exit Do
      w=w * (36 - t)
      k=k+36
    Loop

    bias = PunyAdapt(i - oldi, outBufPos + 1, (oldi = 0))
    n=n+ i \ (outBufPos + 1)
    i = i Mod (outBufPos + 1)

    REM insert n at position i of the output
    outStr =left(outStr,i) & ChrW(n) & mid(outStr,i+1)
    i=i+1

    REM prepare next loop
    outBufPos=outBufPos+1
  Loop

  PunyDecode=outStr
End Function

Function PunyDecodeDigit(ByVal ascVal)
  If ascVal >= 65 And ascVal <= 90 Then
    PunyDecodeDigit=ascVal - 65
  ElseIf ascVal >= 97 And ascVal <= 122 Then
    PunyDecodeDigit=ascVal - 97
  ElseIf ascVal >= 48 And ascVal <= 57 Then
    PunyDecodeDigit=ascVal - 22
  Else
    Err.Raise vbObjectError + 513, , "Not a valid punycode domain. Bad input."
  End If
End Function

Function PunyEncodeDigit(ByVal dgVal)
  If dgVal < 26 Then
    PunyEncodeDigit=Chr(97 + dgVal)
  ElseIf dgVal < 36 Then
    PunyEncodeDigit=Chr(22 + dgVal)
  Else
    Err.Raise vbObjectError + 513, , "Bad value for punycode digit encoding"
  End If
End Function

Function PunyAdapt(ByVal delta, ByVal numpoints, ByVal firsttime)
dim k
  delta = IIf(firsttime, delta \ 700, delta \ 2)
  delta=delta + delta \ numpoints
  k=0
  While delta > 455
    delta=delta \ 35
    k=k+36
  Wend
  PunyAdapt= k + 36 * delta \ (delta + 38)
End Function

Function PunyEncode(ByVal uc)
  Dim j, t, outStr, n, delta, bias, h, b, m, q, k
  outStr = ""
  n= 128
  delta= 0
  bias= 72

  REM handle the basic code points
  For j = 1 To len(uc)
    If AscW(mid(uc,j,1)) < 128 Then outStr=outStr & Lcase(mid(uc,j,1))
  Next

  h=Len(outStr)
  b=h
  If b > 0 Then outStr=outStr & "-"

  REM main encoding loop
  While h < len(uc)
    m=-1
    For j = 1 To len(uc)
      If AscW(mid(uc,j,1)) >= n And (m = -1 Or AscW(mid(uc,j,1)) < m) Then m = AscW(mid(uc,j,1))
    Next
    delta=delta + (m - n) * (h + 1)
    n = m

    For j = 1 To len(uc)
      If AscW(mid(uc,j,1)) < n Then delta=delta + 1
      If AscW(mid(uc,j,1)) = n Then
        q= delta
        k = 36
        Do
          t = IIf(k <= bias, 1, IIf(k >= bias + 26, 26, k - bias))
          If q < t Then Exit Do
          outStr=outStr & PunyEncodeDigit(t + (q - t) Mod (36 - t))
          q = (q - t) \ (36 - t)
          k =k+ 36
        Loop
        outStr=outStr & PunyEncodeDigit(q)
        bias = PunyAdapt(delta, h + 1, h = b)
        delta = 0
        h =h + 1
      End If
    Next
    delta=delta+1
    n=n+1
  Wend

  PunyEncode=outStr
End Function
%>